figure; hold on;


D1 = 18.75;
orig_array = [0,0];
for j=1:3
    delta_here = [j*D1,0];
    orig_array = [orig_array; orig_array(1,:) + delta_here];
    orig_array = [orig_array; orig_array(1,:) - delta_here];
end
line_orig_array = orig_array;

D2 = 9.2;
D3 = 15.475;
tempp =  line_orig_array;
tempp(:,1) = tempp(:,1) + D2;
tempp(:,2) = tempp(:,2) + D3;
orig_array = [orig_array; tempp];
orig_array = [orig_array; -tempp];
orig_array(12:2:14,1) = orig_array(12:2:14,1) - 0.5;
orig_array(15:1:21,1) = orig_array(15:1:21,1) - 0.25;
orig_array(16:2:end,1) = orig_array(16:2:end,1) - 0.2;
orig_array(17:2:end,1) = orig_array(17:2:end,1) + 0.2;
orig_array(17:2:end,2) = orig_array(17:2:end,2) - 0;
orig_array(19:2:end,1) = orig_array(19:2:end,1) + 0.3;

D2 = 9.375;
D3 = 15.2;
tempp =  line_orig_array;
tempp(:,1) = tempp(:,1) + 2*D2;
tempp(:,2) = tempp(:,2) + 2*D3;
orig_array = [orig_array; tempp];
orig_array = [orig_array; -tempp];

D2 = 9.375;
D3 = 15.1;
tempp =  line_orig_array;
tempp(:,1) = tempp(:,1) + 3*D2;
tempp(:,2) = tempp(:,2) + 3*D3;
orig_array = [orig_array; tempp];
orig_array = [orig_array; -tempp];


markerarray = ['*','o','+','s','<','>','d'];
colorarray = ['r','g','b','m','c','k'];

RANGE = BNUM;
RANGEp1 = RANGE+1;
pointmap = zeros(RANGEp1,RANGEp1);
COLOR_NUM = 291;
COLOR_PERMUTE = randperm(COLOR_NUM);
COLOR_PERMUTE = 1:COLOR_NUM;
colormap = cell(1,COLOR_NUM); 
for j=1:COLOR_NUM colormap{j}.pntrcd = []; end

SHIFT = round(RANGE/2)+1;
for j=1:size(orig_array,1)
    orig = orig_array(j,1:2);    
    count = 0;
    for x=-12+orig(1):12+orig(1)
        for y=-12+orig(2):12+orig(2)
            if checkinhexagon(orig(1),orig(2),10.4,x,y)
                rx = round(x);
                ry = round(y); 
                count = count + 1;
                %text(round(x),round(y),str2, 'Color', 'k');
                if rx+SHIFT <= RANGEp1 && ry+SHIFT <= RANGEp1 && rx+SHIFT >0 && ry+SHIFT > 0
                    %plot(rx, ry ,markerarray(mod(j-1,length(markerarray))+1), 'Color', colorarray(mod(j-1,length(colorarray))+1));
                    plot(rx+SHIFT, ry+SHIFT,markerarray(mod(j-1,length(markerarray))+1), 'Color', colorarray(mod(j-1,length(colorarray))+1));
                    str2 = sprintf('%d',count);
                    oldcolor = pointmap(rx+SHIFT,ry+SHIFT);
                    thiscolor = COLOR_PERMUTE(count);
                    pointmap(rx+SHIFT,ry+SHIFT) = thiscolor;
                    colormap{thiscolor}.pntrcd = [colormap{thiscolor}.pntrcd; [rx,ry]];
                    if oldcolor > 0
                        for zzz=1:size(colormap{oldcolor}.pntrcd,1)
                            thisdiff = colormap{oldcolor}.pntrcd(zzz,1:2) - [rx,ry];
                            if sum(abs(thisdiff)) == 0
                                rmvrcd = zzz;
                                break;
                            end
                        end
                        colormap{oldcolor}.pntrcd(rmvrcd,:) = [];
                    end
                end
            end
        end
    end
    count
end
hold off;


% -------------------------------------------------------------------------
for cidx=1:COLOR_NUM
    numpt = size(colormap{cidx}.pntrcd,1);
    distmat = zeros(numpt,numpt);
    for j=1:numpt
        for jj=1:numpt
            if j==jj
                distmat(j,jj) = 99.999;
            else
                pt1 = colormap{cidx}.pntrcd(j,:);
                pt2 = colormap{cidx}.pntrcd(jj,:);
                distdiff = pt1-pt2;
                distmat(j,jj) = norm(distdiff);
            end
        end
    end
    fprintf(1,'color %d, min dist %f\n', cidx, min(min(distmat)));
end

% -------------------------------------------------------------------------

LAYER_NUM = 14;
seed_COLOR_NUM = COLOR_NUM;
COLOR_NUM = seed_COLOR_NUM * LAYER_NUM;
seed_pointmap = pointmap;
pointmap = zeros(RANGEp1,RANGEp1,RANGEp1);
seed_colormap = colormap;
colormap = cell(1,COLOR_NUM); 
for j=1:COLOR_NUM colormap{j}.pntrcd = []; end
for z=-LAYER_NUM/2:LAYER_NUM/2-1
    for x=-RANGE/2:RANGE/2
        for y=-RANGE/2:RANGE/2
            if seed_pointmap(x+SHIFT,y+SHIFT)
                thiscolor = seed_pointmap(x+SHIFT,y+SHIFT) + (z+LAYER_NUM/2)*seed_COLOR_NUM;
                pointmap(x+SHIFT,y+SHIFT,z+SHIFT) = thiscolor;
                colormap{thiscolor}.pntrcd = [colormap{thiscolor}.pntrcd; [x+SHIFT,y+SHIFT,z+SHIFT]];
            end
        end
    end
end

vD1 = 10;
vD2 = 5;


for z=LAYER_NUM/2:LAYER_NUM+LAYER_NUM/2-1
    for sx=-RANGE/2:RANGE/2
        for sy=-RANGE/2:RANGE/2
            x = sx + vD1;
            y = sy + vD2;
            if x+SHIFT > RANGEp1 || y+SHIFT > RANGEp1 continue; end
            if seed_pointmap(x+SHIFT,y+SHIFT)
                thiscolor = pointmap(x+SHIFT,y+SHIFT,z+SHIFT-LAYER_NUM);
                pointmap(sx+SHIFT,sy+SHIFT,z+SHIFT) = thiscolor;
                colormap{thiscolor}.pntrcd = [colormap{thiscolor}.pntrcd; [sx+SHIFT,sy+SHIFT,z+SHIFT]];
            end
        end
    end
end



for z=-LAYER_NUM-LAYER_NUM/2:-LAYER_NUM/2-1
    for sx=-RANGE/2:RANGE/2
        for sy=-RANGE/2:RANGE/2
            x = sx + vD1;
            y = sy + vD2;
            if x+SHIFT > RANGEp1 || y+SHIFT > RANGEp1 continue; end
            if seed_pointmap(x+SHIFT,y+SHIFT) 
                thiscolor = pointmap(x+SHIFT,y+SHIFT,z+SHIFT+LAYER_NUM);
                pointmap(sx+SHIFT,sy+SHIFT,z+SHIFT) = thiscolor;
                colormap{thiscolor}.pntrcd = [colormap{thiscolor}.pntrcd; [sx+SHIFT,sy+SHIFT,z+SHIFT]];
            end
        end
    end
end

% -------------------------------------------------------------------------
mindisvals = [];
for cidx=1:COLOR_NUM
    numpt = size(colormap{cidx}.pntrcd,1);
    distmat = ones(numpt,numpt)*10000;
    for j=1:numpt-1
        for jj=j+1:numpt
            pt1 = colormap{cidx}.pntrcd(j,:);
            pt2 = colormap{cidx}.pntrcd(jj,:);
            distdiff = pt1-pt2;
            distmat(j,jj) = norm(distdiff);
        end
    end
    mindisvals(cidx) = min(min(distmat));
    if mod(cidx,100) == 0
        fprintf(1,'color %d, min dist %f\n', cidx, min(min(distmat)));
    end
end
