anatrans = cell(1,maxerr);
for errnum=1:maxerr
    fprintf(1,'ana cal come to errnum %d\n', errnum);
    anatrans{errnum} = zeros(BNUM+1,BNUM+1);
    errR = errnum / M;
    blockflip_p = 0;
    for j=0:BLEN
        if mod(j,2) == 0 continue; end
        blockflip_p = blockflip_p + binopdf(j,BLEN,errR);
    end
    flippmat = zeros(BNUM+1,BNUM+1);
    for j=0:BNUM
        for cj=0:j
            flippmat(j+1,cj+1) = binopdf(cj,j,blockflip_p);
        end
    end
    for j=0:BNUM
        r = BNUM-j;
        for cj=0:j
            for cr=0:r
                nj = j-cj+cr;
                cjp = flippmat(j+1,cj+1);
                crp = flippmat(r+1,cr+1);
                anatrans{errnum}(j+1,nj+1) = anatrans{errnum}(j+1,nj+1) + cjp*crp;
            end
        end
    end
end

